///////////////////////////////////////////////////////////////////////////////////////////
//
// MNEMONIC.CPP - Description of AMnemonicSample, the mnemonic sample application
//
// (c) 1998 by Stefan Ruck, Frankfurt/Main, Germany
//
///////////////////////////////////////////////////////////////////////////////////////////

#include <os2.h>

#ifndef _IAPP_
#include <iapp.hpp>
#endif

#ifndef _ISYSMENU_
#include <isysmenu.hpp>
#endif

#ifndef _MNEMONIC_HPP_
#include "Mnemonic.hpp"
#endif

#include "mnemonic.rch"
#include "dialog.h"

#ifndef _ABOUT_HPP_
#include "about.hpp"
#endif


//*************************************************************************
// main  - Application entry point                                        *
//*************************************************************************
int main(int argc, char ** argv)
{
  AMnemonicSample mainWindow;

  IApplication :: current (). run ();

  return (0);
}

//*************************************************************************
// AMnemonicSample :: AMnemonicSample - Constructor of AMnemonicSample    *
//*************************************************************************

AMnemonicSample :: AMnemonicSample ()
                   : IFrameWindow (DLG_SAMPLE)
{
  ICommandHandler :: handleEventsFor (this);  // handle commands

  // Add the 'Product Information' item into the system menu

  ISystemMenu systemMenu (this);

  systemMenu. addSeparator (ISystemMenu :: idPulldown);

  systemMenu. addText (MI_ABOUT, "~Product information", ISystemMenu :: idPulldown);

  show ();
}

//*********************************************************************
// AMnemonicSample :: command - handles Command-Events                *
//*********************************************************************
Boolean AMnemonicSample :: command(ICommandEvent &evt)
{
  switch (evt.commandId())
          {
           case DID_OK:
                close ();
                break;
           case MI_ABOUT:
                {
                 AAbout dlgAbout (this);
                 dlgAbout. showModally ();
                 break;
                }
           default:
                return (false);
          }

  return (true);
}
