#include <glut.h>
#include "glwindow.h"

#define FOVY            40.0
#define MINVIEWDISTANCE 100.0
#define MAXVIEWDISTANCE 1000.0

GLfloat roll = 0.0;
GLfloat pitch = 0.0;
GLfloat yaw = 0.0;
GLfloat zoom = -250.0;

enum state { MOVE_NONE=0, MOVE_ZOOM, MOVE_ROTATE };
GLint mouseState = MOVE_NONE;
GLint zoomPos = 0.0;

/* openGL settings */
void setWindowSize( int width, int height )
{
   /* setup the 3D perspective window */
   glMatrixMode( GL_PROJECTION );
   glLoadIdentity();
   gluPerspective( FOVY, (float)width / (float)height, MINVIEWDISTANCE, MAXVIEWDISTANCE );
   glMatrixMode( GL_MODELVIEW );
   /* make a viewport the acual size of the window */
   glViewport( 0, 0, width, height );
}

void mouseFunc( int button, int state, int x, int y )
{
   switch( button )
   {
      case GLUT_LEFT_BUTTON:
         /* zoom */
         switch( state )
         {
            case GLUT_DOWN:
               /* store the down spot for later */
               zoomPos = y;
               mouseState = MOVE_ZOOM;
               break;
            case GLUT_UP:
               mouseState = MOVE_NONE;
               break;
         }
         break;
   }
}

void mouseMotionFunc( int x, int y )
{
   /* find out what action to perform */
   switch( mouseState )
   {
      case MOVE_ZOOM:
         /* change zoom and reset reference */
         zoom += ( zoomPos - y );
         zoomPos = y;
         break;
   }
}

void idleFunc()
{
   /* tell glut that we want our window updated */
   glutPostRedisplay();
}

void paintWindow( )
{
   /* clear the buffer */
   glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );

   /* no rotations */
   glLoadIdentity();

   /* move the image back from the camera */
   glTranslatef( 0.0, 0.0, zoom );
   glRotatef( roll, 0.0, 1.0, 0.0 );
   glRotatef( pitch, 0.0, 1.0, 0.0 );
   glRotatef( yaw, 0.0, 1.0, 0.0 );

   /* placeholder object */
   glutWireTorus( 25.0, 50.0, 15, 15 );

   /* swap the back draw buffer to the front */
   glutSwapBuffers( );
}

void menuFuncMain( int id )
{
}

void menuFuncDisplay( int id )
{
}

void menuFuncLoad( int id )
{
}
